Attribute VB_Name = "shopify"
Option Explicit

Sub shopify()

Dim lr As Long
lr = Range("A1", Range("A1").End(xlDown)).Cells.Count
Dim vr As Long
vr = Range("A1:A" & lr).SpecialCells(xlCellTypeVisible).Cells.Count

    'SPLIT TO COLUMNS AND ASSIGN IMPORTANT FORMATS
    'Range("K2:O" & lr).ClearFormats
    'Range("K2:O" & lr).NumberFormat = "0.00"
    'Range("B2:B" & lr).Select
    'Selection.NumberFormat = "0"
    'Selection.EntireColumn.AutoFit
    
    Dim comOrSc As Range
    Set comOrSc = Range("A1").Find(",")
    If comOrSc Is Nothing Then
        Range("A1:A" & lr).Select
        Selection.TextToColumns Destination:=Range("A1"), DataType:=xlDelimited, _
        TextQualifier:=xlDoubleQuote, ConsecutiveDelimiter:=False, Tab:=True, _
        Semicolon:=True, TrailingMinusNumbers:=True
    Else
        Range("A1:A" & lr).Select
        Selection.TextToColumns Destination:=Range("A1"), DataType:=xlDelimited, _
        TextQualifier:=xlDoubleQuote, ConsecutiveDelimiter:=False, Tab:=True, _
        Comma:=True, TrailingMinusNumbers:=True
    End If


    'DELETE "PENDING " AND "IN TRANSIT"
    'Check for existence of pendiong and in transit transactions
    Dim counter As Long
    counter = 0
    Dim i As Long
    For i = 2 To lr
        If InStr(Range("F" & i).Text, "in_transit") <> 0 Or InStr(Range("F" & i).Text, "pending") <> 0 Then
            counter = counter + 1
        End If
    Next i
    
    
    'Filter and delete in_transit and pending
    If counter > 0 Then
    Range("A1:M1").AutoFilter Field:=6, Criteria1:="in_transit", _
    Operator:=xlOr, Criteria2:="pending"
    Range("A2:M" & lr).SpecialCells(xlCellTypeVisible).EntireRow.Delete
    End If
    
    
    Range("A1:M1").AutoFilter

    Range("I2:K" & lr).Select
    Selection.NumberFormat = "0.00"
    Range("G1").EntireColumn.AutoFit
    Range("H1").EntireColumn.AutoFit
    
    
    'Convert columns I-J-K from text to number format
    Dim ar As Variant
    Dim var As Variant
   

    lr = Range("A" & Rows.Count).End(xlUp).Row
    
    'Column I
    ar = Range("I2:I" & lr)
    ReDim var(1 To UBound(ar), 1 To 1)
    For i = 1 To UBound(ar) 'Start of VBA loop
    var(i, 1) = ar(i, 1) * 1
    Next i
    Range("I2:I" & lr) = var
    
    'Column J
    ar = Range("J2:J" & lr)
    'ReDim var(1 To UBound(ar), 1 To 1)
    For i = 1 To UBound(ar) 'Start of VBA loop
    var(i, 1) = ar(i, 1) * 1
    Next i
    Range("J2:J" & lr) = var
    
    'Column K
    ar = Range("K2:K" & lr)
    'ReDim var(1 To UBound(ar), 1 To 1)
    For i = 1 To UBound(ar) 'Start of VBA loop
    var(i, 1) = ar(i, 1) * 1
    Next i
    Range("K2:K" & lr) = var
    
    
    Range("H1").Select
    'Insert new column D
    Columns(4).Insert
    Range("D1:D" & lr).FormulaR1C1 = "=RC[-1]&"" ""&RC[-2]"
    
    'Insert new column A
    Columns(1).Insert
    lr = Range("B1", Range("B1").End(xlDown)).Cells.Count
    Range("A2").Select
    ActiveCell.FormulaR1C1 = _
        "=MID(RC[1],9,2)&"".""&MID(RC[1],6,2)&"".""&MID(RC[1],1,4)"
    
    Range("A2").Copy
    Range("A2").Select
    
    Selection.AutoFill Destination:=Range("A2:A" & lr), Type:=xlFillDefault
   
   'First row titles
    Range("A1") = "Buchungsdatum"
    Range("D1") = "Zahlungsreferenz"
    Range("E1") = "Empfnger/Zahlungspflichtiger"
    Range("F1") = "Auftragsart"
    Range("H1") = "Buchungstext"
    Range("K1") = "Betrag"
    Range("N1") = "Verwendungszweck"
    
   'Last row descriptions
    Range("A" & lr + 1).Select
    Selection = Range("I2").Value
    Range("A" & lr + 1).NumberFormat = "dd.mm.yyyy"
    Range("C" & lr + 1) = "Gebhren"
    Range("D" & lr + 1) = "Shopify"
    Range("E" & lr + 1) = "Gebhren " & Range("A" & lr).Value & " - " & Range("A2").Value
    Range("H" & lr + 1) = "Shopify Gebhren"
    Range("K" & lr + 1) = Application.WorksheetFunction.Sum(Range("L2:L" & lr)) * -1
    
    Cells.Select
    Selection.Copy
    Range("a1").PasteSpecial (xlPasteValues)
    Range("A1").Select
    Application.CutCopyMode = False
    
    
    
    Range("B1:C1") = "Irrelevant"
    Range("G1") = "Irrelevant"
    Range("I1:J1") = "Irrelevant"
    Range("L1:M1") = "Irrelevant"
    Range("O1:Q1") = "Irrelevant"
    
    
    'Delete Irrelevant columns
    Dim mc As Long
    mc = ActiveSheet.UsedRange.Columns.Count
    
    For i = mc To 1 Step -1
        If ActiveSheet.Cells(1, i).Value = "Irrelevant" Then
             ActiveSheet.Cells(1, i).EntireColumn.Delete 'xlshiftleft
        End If
    Next i
    
    lr = Range("A" & Rows.Count).End(xlUp).Row
    
    'Delete empty rows at the bottom
    Range("A" & lr + 1 & ":A" & lr + 10).EntireRow.Select
    Selection.Delete
    Range("A1").Select
        
End Sub














